package ubiik.utils;

public class CRC {
  public static short crc16(byte[] data) {
    int length = data.length;
    int i = 0;
    int crc = 65535;
    while (length-- > 0) {
      int x = crc >>> 8 ^ 0xFF & data[i++];
      x ^= x >>> 4;
      crc = 0xFFFF & (crc << 8 ^ x << 12 ^ x << 5 ^ x);
    } 
    return (short)(0xFFFF & crc);
  }
  
  public static short crc16(byte[] data, int iStart, int iStop) {
    int crc = 65535;
    for (int i = iStart; i < iStop; i++) {
      int x = crc >>> 8 ^ 0xFF & data[i];
      x ^= x >>> 4;
      crc = 0xFFFF & (crc << 8 ^ x << 12 ^ x << 5 ^ x);
    } 
    return (short)(0xFFFF & crc);
  }
}
