package ubiik.utils.view;

import javafx.application.Platform;
import javafx.beans.value.ObservableValue;
import javafx.geometry.Bounds;
import javafx.scene.control.ProgressBar;
import javafx.scene.layout.Region;
import javafx.scene.shape.Rectangle;
import javafx.stage.FileChooser;

public class ViewUtils {
  public static void clipChildren(Region region, double arc) {
    Rectangle outputClip = new Rectangle();
    outputClip.setArcWidth(arc);
    outputClip.setArcHeight(arc);
    region.setClip(outputClip);
    region.layoutBoundsProperty().addListener((ov, oldValue, newValue) -> {
          outputClip.setWidth(newValue.getWidth());
          outputClip.setHeight(newValue.getHeight());
        });
  }
  
  public static FileChooser getImageFileChooser() {
    FileChooser fileChooser = new FileChooser();
    FileChooser.ExtensionFilter extFilterJPG = new FileChooser.ExtensionFilter("JPG  (*.jpg)", new String[] { "*.JPG" });
    FileChooser.ExtensionFilter extFilterPNG = new FileChooser.ExtensionFilter("PNG (*.png)", new String[] { "*.PNG" });
    FileChooser.ExtensionFilter extFilterBMP = new FileChooser.ExtensionFilter("BMP (*.bmp)", new String[] { "*.BMP" });
    fileChooser.getExtensionFilters().addAll(new FileChooser.ExtensionFilter[] { extFilterJPG, extFilterPNG, extFilterBMP });
    return fileChooser;
  }
  
  public static final void updateProgressBar(final ProgressBar progressBar, final int progress, final int total) {
    Platform.runLater(new Runnable() {
          public void run() {
            double prgs = total;
            if (total != 0)
              prgs = progress / total; 
            progressBar.setProgress(prgs);
          }
        });
  }
}
