package ubiik.wp.admin;

import javafx.fxml.FXMLLoader;
import javafx.stage.Stage;
import ubiik.wp.admin.psconnection.auth.TPPSAuthAdmin;
import ubiik.wp.admin.view.TPMainViewController;
import ubiik.wp.controller.DevicesController;
import ubiik.wp.controller.MessageController;
import ubiik.wp.controller.UserManager;
import ubiik.wp.psconnection.auth.PSAuth;
import ubiik.wp.view.BaseApplication;
import ubiik.wp.view.ConnectionManagerViewController;

public class TPAdminMain extends BaseApplication {
  protected void doSetUpMainController(Stage stage, DevicesController dc, MessageController mc) {
    this.mainLoader = new FXMLLoader(getClass().getResource("/main/resources/ubiik/wp/admin/TPMainView.fxml"));
    this.mainController = (ConnectionManagerViewController)new TPMainViewController(stage, mc, dc);
    this.mainLoader.setController(this.mainController);
  }

  protected static void setUpUserManager() {
    UserManager usrManager = UserManager.getInstance();
    usrManager.setPsAuth((PSAuth)new TPPSAuthAdmin());
  }

  public static void main(String[] args) {
    setUpUserManager();
    launch(args);
  }
}
