package ubiik.wp.admin.model.atcommand;

import java.util.Arrays;
import java.util.List;

public class ATCommand {
  public static final String AT_ROOT = "AT";
  
  public static final String USER_AT = "AT+";
  
  public static final String AT_ECHO = "E";
  
  public static final String AT_LOGMASK = "LOGMASK";
  
  public static final String AT_UUEID = "UUEID";
  
  public static final String AT_CREG = "CREG";
  
  public static final String AT_UNSOLICITED = "+";
  
  public static final int AT_ECHO_OFF = 0;
  
  public static final char AT_CMD_TRAILING_CHAR = '\r';
  
  public static final char AT_CMD_END_OF_LINE_CHAR = '\n';
  
  public enum UUTASKS {
    AT_TASK, RRM_TASK, LL_TASK, BB_CTRL_TASK, PHY_TASK, RF_TASK, LOG_TASK, APP_TASK, EPD_TASK, MON_TASK;
  }
  
  public static String standarizeATCommand(String atCmd) {
    int idx = atCmd.indexOf('=');
    if (idx >= 0) {
      String leading = atCmd.substring(0, idx + 1).toUpperCase();
      return leading + leading;
    } 
    return atCmd.toUpperCase();
  }
  
  public static final String query(String atCmd) {
    return standarizeATCommand("AT+" + atCmd + "?");
  }
  
  public static final String get(String atCmd) {
    return standarizeATCommand("AT+" + atCmd + "=?");
  }
  
  public static final String set(String atCmd, List<String> params) {
    String cmd = "AT+" + atCmd + "=";
    int pCount = 0;
    for (int i = 0; i < params.size(); i++) {
      if (((String)params.get(i)).length() > 0) {
        if (i > 0)
          cmd = cmd + ","; 
        cmd = cmd + cmd;
        pCount++;
      } 
    } 
    if (pCount > 0)
      return standarizeATCommand(cmd); 
    return null;
  }
  
  public static final String set(String atCmd, String param) {
    return set(atCmd, Arrays.asList(new String[] { param }));
  }
  
  public static final String execute(String atCmd) {
    return standarizeATCommand("AT+" + atCmd);
  }
}
