package ubiik.wp.admin.view;

import java.io.InputStream;
import javafx.application.Platform;
import javafx.stage.Stage;
import ubiik.wp.controller.DevicesController;
import ubiik.wp.controller.MessageController;
import ubiik.wp.model.firmwareupgrade.BSFirmwareFileManager;
import ubiik.wp.view.AppSettingsViewController;
import ubiik.wp.view.CommandStatusReceiver;
import ubiik.wp.view.ConnectionManagerViewController;
import ubiik.wp.view.MainViewController;

public class TPMainViewController extends MainViewController {
  public TPMainViewController(Stage primaryStage, MessageController mc, DevicesController dc) {
    super(primaryStage, mc, dc);
    primaryStage.setTitle("Taipower Config Tool");
  }
  
  public void authenticationFinished(final boolean autheticated) {
    final TPMainViewController csr = this;
    Platform.runLater(new Runnable() {
          public void run() {
            try {
              Thread.sleep(1000L);
            } catch (InterruptedException e) {
              e.printStackTrace();
            } 
            boolean apply = false;
            if (autheticated) {
              TPMainViewController.this.settingsViewController = new AppSettingsViewController(TPMainViewController.this.primaryStage, (ConnectionManagerViewController)csr, TPMainViewController.this
                  .devicesController, TPMainViewController.this.messageController, (CommandStatusReceiver)csr);
              InputStream resource = TPMainViewController.class.getResourceAsStream("/fw.pkg");
              byte[] currentVersion = TPMainViewController.this.devicesController.getBsVersion();
              byte[] pckVersion = { 1, 0, 10, 16 };
              int compareResult = BSFirmwareFileManager.compareVersions(pckVersion, currentVersion);
              if (compareResult > 0) {
                apply = true;
                TPMainViewController.this.settingsViewController.doFWUpgrade(resource, false, true);
              } 
            } 
            if (!apply)
              csr.doAuthenticationFinished(autheticated); 
          }
        });
  }
  
  public void doAuthenticationFinished(boolean autheticated) {
    super.authenticationFinished(autheticated);
  }
}
