package ubiik.wp.ami.model;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import ubiik.wp.ami.model.DLMSObis;

public class AmiAppObis extends AMIMessage {
  private DLMSObis dlmsObis;
  
  public AmiAppObis(byte[] bytes) {
    super(bytes);
    if (bytes.length < 8)
      throw new IllegalArgumentException("Data is too small for AmiAppObis"); 
    ByteBuffer buf = ByteBuffer.wrap(bytes).order(ByteOrder.LITTLE_ENDIAN);
    buf.position(2);
    this.dlmsObis = new DLMSObis(buf);
  }
  
  public DLMSObis getDlmsObis() {
    return this.dlmsObis;
  }
  
  protected AmiComparisonResult doAmiCompare(AMIMessage other) {
    return new AmiComparisonResult(false, "Not implemented");
  }
}
