package ubiik.wp.ami.model;

import java.io.IOException;
import org.json.simple.JSONObject;
import ubiik.utils.JsonUtils;

public class AmiCustom extends AMIMessage {
  public AmiCustom(JSONObject json) {
    super(JsonUtils.getByteIfExists(json, "messageId").byteValue(), 
        getDirectionForKey((String)json.get("dir")));
    byte[] pload = JsonUtils.getByteArr(json, "amiPayload");
    try {
      this.payload.write(pload);
    } catch (IOException e) {
      e.printStackTrace();
    } 
  }
  
  protected AmiComparisonResult doAmiCompare(AMIMessage other) {
    AmiCustom customOther = (AmiCustom)other;
    Boolean success = Boolean.valueOf(true);
    StringBuilder message = new StringBuilder();
    success = compareIfNotNull(getPayload(), customOther.getPayload(), success, message, "payload didn't match\n");
    return new AmiComparisonResult(success.booleanValue(), message.toString());
  }
}
