package ubiik.wp.ami.model;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import org.json.simple.JSONObject;
import ubiik.utils.JsonUtils;

public class AmiMeterKeys extends AMIMessage {
  public static final int KEY_SIZE = 16;
  
  public static final int KEY_SIZE_WRAPPED = 24;
  
  private byte[] GUK;
  
  private byte[] AK;
  
  public AmiMeterKeys(byte[] bytes, int keySize) {
    super(bytes);
    if (bytes.length < 2 + 2 * keySize)
      throw new IllegalArgumentException("Data is too small for AmiMeterKeys"); 
    this.GUK = new byte[keySize];
    this.AK = new byte[keySize];
    ByteBuffer buf = ByteBuffer.wrap(bytes).order(ByteOrder.LITTLE_ENDIAN);
    buf.position(2);
    buf.get(this.GUK, 0, 16);
    buf.get(this.AK, 0, 16);
  }
  
  public AmiMeterKeys(AMIMessage.Direction dir, byte[] GUK, byte[] AK) {
    super((byte)0, dir);
    this.GUK = GUK;
    this.AK = AK;
    try {
      this.payload.write(this.GUK);
      this.payload.write(this.AK);
    } catch (IOException e) {
      e.printStackTrace();
    } 
  }
  
  public AmiMeterKeys(JSONObject json) {
    super(json);
    this.GUK = JsonUtils.getByteArr(json, "guk");
    this.AK = JsonUtils.getByteArr(json, "ak");
    try {
      this.payload.write(this.GUK);
      this.payload.write(this.AK);
    } catch (IOException e) {
      e.printStackTrace();
    } 
  }
  
  protected AmiComparisonResult doAmiCompare(AMIMessage other) {
    return new AmiComparisonResult(false, "Not implemented");
  }
  
  public byte[] getGUK() {
    return this.GUK;
  }
  
  public byte[] getAK() {
    return this.AK;
  }
}
