package ubiik.wp.ami.model;

import java.io.IOException;
import java.util.Random;
import org.apache.commons.lang3.NotImplementedException;
import org.json.simple.JSONObject;
import ubiik.utils.JsonUtils;

public class AmiRandomPayload extends AMIMessage {
  private static final int DEFAULT_PAYLOAD_SIZE = 512;
  
  AmiRandomPayload(byte[] bytes) {
    super(bytes);
  }
  
  public AmiRandomPayload(JSONObject json) {
    super(json);
    Integer payloadSize = JsonUtils.getIntIfExists(json, "size");
    if (payloadSize == null)
      payloadSize = Integer.valueOf(512); 
    byte[] bytes = new byte[payloadSize.intValue()];
    (new Random()).nextBytes(bytes);
    try {
      this.payload.write(bytes);
    } catch (IOException e) {
      e.printStackTrace();
    } 
  }
  
  protected AmiComparisonResult doAmiCompare(AMIMessage other) {
    throw new NotImplementedException("AmiRandomPayload can't be compared");
  }
}
