package ubiik.wp.ami.model;

import org.apache.commons.lang3.NotImplementedException;
import org.json.simple.JSONObject;
import ubiik.utils.JsonUtils;

public class AmiSleep extends AMIMessage {
  public static final long DEFAULT_SLEEP_MILLIS = 1000L;
  
  Long millis;
  
  public AmiSleep(JSONObject json) {
    super(json);
    this.millis = JsonUtils.getLongIfExists(json, "millis");
    if (this.millis == null)
      this.millis = Long.valueOf(1000L); 
  }
  
  public byte[] getPayload() {
    try {
      Thread.sleep(this.millis.longValue());
    } catch (InterruptedException e) {
      e.printStackTrace();
    } 
    return null;
  }
  
  protected AmiComparisonResult doAmiCompare(AMIMessage other) {
    throw new NotImplementedException("Can't compare sleep messages");
  }
}
