package ubiik.wp.app.core;

import java.util.Date;
import ubiik.wp.model.messages.PSUplink;

public class UplinkSample {
  protected PSUplink uplink;
  
  private UplinkSampleHeader header;
  
  public UplinkSample(PSUplink uplink, UplinkSampleHeader header) {
    this.uplink = uplink;
    this.header = header;
  }
  
  public synchronized Date getTimestamp() {
    return this.header.getTimestamp();
  }
  
  public synchronized void setTimestamp(Date timestamp) {
    this.header.setTimestamp(timestamp);
  }
  
  public synchronized String getEndDeviceUUEID() {
    if (this.uplink != null)
      return this.uplink.getTargetString(); 
    return null;
  }
  
  public PSUplink getUplink() {
    return this.uplink;
  }
  
  public byte getApplicationType() {
    return this.header.getApplicationType();
  }
  
  public byte getApplicationSubType() {
    return this.header.getApplicationSubType();
  }
}
