package ubiik.wp.controller;

import com.opencsv.bean.CsvToBeanBuilder;
import java.io.FileReader;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import ubiik.wp.util.ApplicationLogger;

public class BaseStationNameManager {
  private Map<String, String> bsNames = new HashMap<>();
  
  private static class Holder {
    static final BaseStationNameManager INSTANCE = new BaseStationNameManager();
  }
  
  public static BaseStationNameManager getInstance() {
    return Holder.INSTANCE;
  }
  
  public void loadNamesFromPath(String path) {
    try {
      this.bsNames.clear();
      List<CSVDevice> beans = (new CsvToBeanBuilder(new FileReader(path))).withType(CSVDevice.class).build().parse();
      for (CSVDevice bs : beans)
        this.bsNames.put(bs.getUuid(), bs.getName()); 
    } catch (Exception e) {
      ApplicationLogger.debug("Failed to load Base Station names");
    } 
  }
  
  public String getNameForUUID(String uuid) {
    return this.bsNames.get(uuid);
  }
  
  private BaseStationNameManager() {}
}
