package ubiik.wp.controller;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Arrays;
import ubiik.utils.files.FileUtils;
import ubiik.wp.model.messages.pscommands.PSCommandDelegate;
import ubiik.wp.model.messages.pscommands.PSCommandPutFileEx;

public class FileTransferManager {
  private static final int MAX_FRAGMENT_SIZE = 10485760;
  
  private File sourceFile;
  
  private String filename;
  
  private String userName;
  
  private String groupName;
  
  private int permissions;
  
  private int currentOffset;
  
  private byte[] fileBytes;
  
  public FileTransferManager(File sourceFile, String filename, String userName, String groupName, int permissions) {
    this.sourceFile = sourceFile;
    this.filename = filename;
    this.userName = userName;
    this.groupName = groupName;
    this.permissions = permissions;
    this.currentOffset = 0;
    try {
      this.fileBytes = FileUtils.toByteArray(new FileInputStream(this.sourceFile));
    } catch (IOException e) {
      throw new IllegalArgumentException(e.getMessage());
    } 
  }
  
  public PSCommandPutFileEx getNextCommandFileFragment(PSCommandDelegate delegate) {
    PSCommandPutFileEx cmd = null;
    if (this.currentOffset < this.fileBytes.length) {
      int totalBytes = (this.fileBytes.length < this.currentOffset + 10485760) ? (this.fileBytes.length - this.currentOffset) : 10485760;
      cmd = new PSCommandPutFileEx(this.filename, this.userName, this.groupName, this.permissions, this.currentOffset, Arrays.copyOfRange(this.fileBytes, this.currentOffset, this.currentOffset + totalBytes), delegate);
      this.currentOffset += totalBytes;
    } 
    return cmd;
  }
}
