package ubiik.wp.controller;

import java.util.concurrent.BlockingQueue;
import ubiik.wp.model.messages.PSMessage;
import ubiik.wp.model.messages.PSMessageFactory;
import ubiik.wp.util.ApplicationLogger;

public class IncomingMessagesProcessor implements Runnable {
  private BlockingQueue<byte[]> inQueue;
  
  private MessageReceiver delegate;
  
  public IncomingMessagesProcessor(BlockingQueue<byte[]> queue, MessageReceiver delegate) {
    this.inQueue = queue;
    this.delegate = delegate;
  }
  
  public void run() {
    byte[] messageData = null;
    try {
      while (true) {
        try {
          messageData = this.inQueue.take();
          PSMessage message = PSMessageFactory.createMessageFromBytes(messageData);
          if (message != null)
            this.delegate.receiveMessage(message); 
        } catch (IllegalArgumentException e) {
          e.printStackTrace();
        } 
      } 
    } catch (InterruptedException e) {
      ApplicationLogger.debug("IncomingMessagesProcessor interrupted");
      return;
    } 
  }
}
