package ubiik.wp.model.bsparameters;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;

public class BSParameterFactory {
  public static final String KEY_BS_PARAMETERS = "parameters";

  public ArrayList<BSParameter> loadBSParameters(String parametersKey) {
    ArrayList<BSParameter> parameters = new ArrayList<>();
    InputStream in = BSParameterFactory.class.getResourceAsStream("/main/resources/bsparameters_config.json");
    JSONParser jsonParser = new JSONParser();
    try {
      JSONObject root = (JSONObject)jsonParser.parse(new InputStreamReader(in, "UTF-8"));
      JSONArray parametersArray = (JSONArray)root.get(parametersKey);
      for (Object object : parametersArray) {
        try {
          JSONObject jObject = (JSONObject)object;
          Long index = (Long)jObject.get("index");
          index = Long.valueOf((index != null) ? index.longValue() : 0L);
          String name = (String)jObject.get("name");
          name = (name != null) ? name : "";
          String category = (String)jObject.get("category");
          category = (category != null) ? category : "";
          String uiName = (String)jObject.get("ui_name");
          uiName = (uiName != null) ? uiName : "";
          String description = (String)jObject.get("description");
          description = (description != null) ? description : "";
          Long min = (Long)jObject.get("min");
          Long max = (Long)jObject.get("max");
          min = Long.valueOf((min != null) ? min.longValue() : 0L);
          max = Long.valueOf((max != null) ? max.longValue() : 4294967295L);
          Long defaultValue = (Long)jObject.get("default");
          defaultValue = (defaultValue != null) ? defaultValue : min;
          BSParameter parameter = new BSParameter(null, defaultValue, min.longValue(), max.longValue(), name, category, uiName, description, index.intValue());
          if (parameter != null)
            parameters.add(parameter);
        } catch (Exception e) {
          e.printStackTrace();
          System.err.println("Error parsing sdr parameter");
        }
      }
    } catch (IOException|org.json.simple.parser.ParseException e) {
      e.printStackTrace();
    }
    return parameters;
  }
}
