package ubiik.wp.model.capacity;

import ubiik.wp.controller.MessageController;
import ubiik.wp.controller.PingManager;
import ubiik.wp.model.devices.UUEndDevice;
import ubiik.wp.model.messages.PSMessage;
import ubiik.wp.model.messages.pscommands.PSCommand;
import ubiik.wp.model.messages.pscommands.PSCommandDelegate;
import ubiik.wp.model.messages.pscommands.PSCommandPingEndDevice;

public class ControlCapacityTest extends MessageCapacityTest implements PSCommandDelegate {
  public static final String CHANNEL_NAME_CONTROL = "Control";
  
  private PingManager pingManager;
  
  public ControlCapacityTest(int frequency, int dataSize, UUEndDevice endDevice, MessageController messageController, PingManager pingManager, int totalMsgs) {
    super(frequency, dataSize, endDevice, messageController, totalMsgs);
    this.pingManager = pingManager;
  }
  
  protected void sendMessage() {
    PSCommandPingEndDevice ping = new PSCommandPingEndDevice(this, getEndDevice().getUuid(), getDataSize(), (int)this.pingManager.getNextPingId());
    getMessageController().sendMessage((PSMessage)ping);
    this.pingManager.addPing(ping);
  }
  
  public void commandandReceivedResponse(PSCommand command) {}
  
  public String getChannelName() {
    return "Control";
  }
  
  public int getChannelCode() {
    return 2;
  }
}
