package ubiik.wp.model.capacity;

import ubiik.wp.controller.MessageController;
import ubiik.wp.model.devices.UUEndDevice;
import ubiik.wp.model.messages.PSDownlink;
import ubiik.wp.model.messages.PSMessage;

public class DownlinkCapacityTest extends MessageCapacityTest {
  public static final String CHANNEL_NAME_ACK = "ACK";
  
  public static final String CHANNEL_NAME_UNACK = "UNACK";
  
  private int endpoint;
  
  public DownlinkCapacityTest(int frequency, int dataSize, UUEndDevice endDevice, int endpoint, MessageController messageController, int totalMsgs) {
    super(frequency, dataSize, endDevice, messageController, totalMsgs);
    if (endpoint == 1 || endpoint == 0) {
      this.endpoint = endpoint;
    } else {
      throw new IllegalArgumentException("Endpoint should be ENDPOINT_ACKNOWLEDGED or ENDPOINT_UNACKNOWLEDGED");
    } 
    if (dataSize > 65535 || dataSize < 5)
      throw new IllegalArgumentException("invalid parameters"); 
  }
  
  protected void sendMessage() {
    byte[] data = UplinkCapacitySample.createPayload(getDataSize(), (int)getCounter() % 256);
    getMessageController().sendMessage((PSMessage)new PSDownlink(data, getEndDevice().getUuid(), this.endpoint));
  }
  
  public String getChannelName() {
    StringBuilder sb = new StringBuilder("Data ");
    if (this.endpoint == 1) {
      sb.append("ACK");
    } else if (this.endpoint == 0) {
      sb.append("UNACK");
    } 
    return sb.toString();
  }
  
  public int getChannelCode() {
    int channelCode = -1;
    if (this.endpoint == 1) {
      channelCode = 0;
    } else if (this.endpoint == 0) {
      channelCode = 1;
    } 
    return channelCode;
  }
}
