package ubiik.wp.model.messages;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public class PSAckMessage extends PSMessageResponse {
  public PSAckMessage(int messageIDtoACK) {
    super(messageIDtoACK, (byte)6);
    this.messageIDtoACK = messageIDtoACK;
  }
  
  public PSAckMessage(byte[] data, int messageId) {
    this.messageId = messageId;
    try {
      ByteBuffer buffer = ByteBuffer.wrap(data).order(ByteOrder.LITTLE_ENDIAN);
      this.messageIDtoACK = 0xFFFF & buffer.getShort();
    } catch (Exception e) {
      throw new IllegalArgumentException();
    } 
  }
  
  protected byte[] getMessageDataBytes() throws MessageFormatException {
    ByteBuffer buffer = ByteBuffer.allocate(2);
    buffer.order(ByteOrder.LITTLE_ENDIAN);
    buffer.putShort((short)(this.messageIDtoACK & 0xFFFF));
    return buffer.array();
  }
}
