package ubiik.wp.model.messages;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;

public class PSMessageJson extends PSMessage {
  private int protocolVersion;
  
  private static final int BYTES_FOR_HEADER_SIZE = 4;
  
  private static final int BYTES_FOR_PAYLOAD_SIZE = 4;
  
  public PSMessageJson(int messageId, byte[] data) {
    super(messageId, 0, data, (byte)9);
    try {
      ByteBuffer buffer = ByteBuffer.wrap(data).order(ByteOrder.LITTLE_ENDIAN);
      int headerSize = buffer.getInt();
      int payloadSize = buffer.getInt();
      this.protocolVersion = buffer.getInt();
      this.data = new byte[payloadSize];
      buffer.position(headerSize + 4 + 4);
      buffer.get(this.data);
    } catch (Exception e) {
      e.printStackTrace();
      throw new IllegalArgumentException();
    } 
  }
  
  protected byte[] getMessageDataBytes() throws MessageFormatException {
    return null;
  }
  
  public JSONObject getJsonObject() {
    JSONParser jsonParser = new JSONParser();
    JSONObject root = null;
    String jsonStr = new String(this.data);
    try {
      root = (JSONObject)jsonParser.parse(jsonStr);
    } catch (Exception e) {
      System.err.println("Error parsing JSON message");
    } 
    return root;
  }
}
