package ubiik.wp.model.messages;
import java.util.Arrays;

public class PSMessageNewDiscovery extends PSMessage {
  public PSMessageNewDiscovery(int messageId, byte[] messageData) {
    super(messageId, 0, messageData, (byte)124);
  }

  public byte[] getDeviceId() {
    return this.data;
  }

  public byte[] getDeviceUUID() {
    // 13 bytes are header, after that until end is UUID.
    byte [] uuid = Arrays.copyOfRange(this.data, 13, this.data.length);
    return uuid;
  }

  protected byte[] getMessageDataBytes() throws MessageFormatException {
    return this.data;
  }
}
