package ubiik.wp.model.messages.pscommands;

import java.lang.reflect.Constructor;
import java.util.HashMap;
import java.util.Map;
import org.json.simple.JSONObject;

public class PSCommandFactory {
  private static Map<String, Class<?>> psCommandClasses = new HashMap<>();
  
  public static final String JSON_KEY_CMD_TYPE = "command";
  
  public static final String JSON_KEY_CMD_SET_CHANNEL = "setChannel";
  
  static {
    psCommandClasses.put("setChannel", PSCommandSetBaseChannel.class);
  }
  
  public static PSCommand createCommand(JSONObject json) {
    PSCommand cmd = null;
    try {
      Class<?> cls = psCommandClasses.get(json.get("command"));
      if (cls != null) {
        Constructor<?> cons = cls.getConstructor(new Class[] { JSONObject.class });
        cmd = (PSCommand)cons.newInstance(new Object[] { json });
      } else {
        System.out.println("Not recognized:");
        System.out.println(json.toJSONString());
      } 
    } catch (Exception e) {
      System.out.println(json.toJSONString());
      e.printStackTrace();
    } 
    return cmd;
  }
}
