package ubiik.wp.model.messages.pscommands.responses;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public class PSCommandResponseBSFirmwareUpgrade extends PSCommandResponse {
  private Integer firmwareUpgradeErrCode;
  
  public PSCommandResponseBSFirmwareUpgrade(int messageId, int commandId, byte[] commandData) {
    super(messageId, commandId, commandData, (short)25);
    byte[] respData = null;
    if (getErrorCode() == 0) {
      try {
        respData = getCommandResponseData();
        ByteBuffer buffer = ByteBuffer.wrap(respData).order(ByteOrder.LITTLE_ENDIAN);
        this.firmwareUpgradeErrCode = Integer.valueOf(buffer.getInt());
      } catch (Exception e) {
        throw new IllegalArgumentException(e.getMessage());
      } 
    } else {
      this.firmwareUpgradeErrCode = null;
    } 
  }
  
  public Integer getFirmwareUpgradeResult() {
    return this.firmwareUpgradeErrCode;
  }
  
  public String getTypeString() {
    return null;
  }
  
  public String getContentString() {
    return null;
  }
  
  public boolean doCompareResponseData(PSCommandResponse other) {
    if (other instanceof PSCommandResponseBSFirmwareUpgrade)
      return (this.firmwareUpgradeErrCode == ((PSCommandResponseBSFirmwareUpgrade)other).getFirmwareUpgradeResult()); 
    return false;
  }
}
