package ubiik.wp.model.messages.pscommands.responses;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public class PSCommandResponseBSParameter extends PSCommandResponse {
  private Long value;
  
  public PSCommandResponseBSParameter(int messageId, int commandId, byte[] commandData) {
    super(messageId, commandId, commandData, (short)16);
    this.value = null;
    ByteBuffer buffer = ByteBuffer.wrap(commandData, 1, commandData.length - 1).order(ByteOrder.LITTLE_ENDIAN);
    if (getErrorCode() == 0 && 
      commandData.length - 1 == 4)
      try {
        this.value = Long.valueOf(buffer.getInt());
      } catch (Exception e) {
        throw new IllegalArgumentException();
      }  
  }
  
  public Long getValue() {
    return this.value;
  }
  
  public String getTypeString() {
    return "Response to Parameter Command";
  }
  
  public String getContentString() {
    return "";
  }
  
  public boolean doCompareResponseData(PSCommandResponse other) {
    if (other instanceof PSCommandResponseBSParameter)
      return (this.value == ((PSCommandResponseBSParameter)other).getValue()); 
    return false;
  }
}
