package ubiik.wp.model.messages.pscommands.responses;

import java.util.Arrays;
import ubiik.utils.DatatypeConverter;

public class PSCommandResponseGeneric extends PSCommandResponse {
  public PSCommandResponseGeneric(int messageId, int commandId, byte[] commandData, short commandType) {
    super(messageId, commandId, commandData, commandType);
  }
  
  public boolean doCompareResponseData(PSCommandResponse other) {
    if (other instanceof PSCommandResponseGeneric)
      return Arrays.equals(getCommandResponseData(), other.getCommandResponseData()); 
    return false;
  }
  
  public String getTypeString() {
    return "Resp to " + this.applicationId;
  }
  
  public String getContentString() {
    String content;
    if (getErrorCode() == 0) {
      content = DatatypeConverter.printHexBinary(this.data);
    } else {
      content = "Error";
    } 
    return content;
  }
}
