package ubiik.wp.model.messages.pscommands.responses;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public class PSCommandResponseGetULBaseChannel extends PSCommandResponse {
  private int channel;
  
  public PSCommandResponseGetULBaseChannel(int messageId, int commandId, byte[] commandData) {
    super(messageId, commandId, commandData, (short)58);
    ByteBuffer buffer = ByteBuffer.wrap(commandData).order(ByteOrder.LITTLE_ENDIAN);
    if (isSuccess()) {
      buffer.position(1);
      this.channel = buffer.getInt();
    } else {
      this.channel = -1;
    } 
  }
  
  public PSCommandResponseGetULBaseChannel(int messageId, int commandId, int channel) {
    super(messageId, commandId, new byte[1], (short)57);
    this.channel = channel;
  }
  
  public int getBaseChannel() {
    return this.channel;
  }
  
  public String getTypeString() {
    return "Response to Read Base Frequency";
  }
  
  public String getContentString() {
    return "Frequency: " + this.channel;
  }
  
  public boolean doCompareResponseData(PSCommandResponse other) {
    if (other instanceof PSCommandResponseGetULBaseChannel)
      return (this.channel == ((PSCommandResponseGetULBaseChannel)other).getBaseChannel()); 
    return false;
  }
}
