package ubiik.wp.model.messages.pscommands.responses;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public class PSCommandResponseStringParameter extends PSCommandResponse {
  private String content;
  
  public PSCommandResponseStringParameter(int messageId, int commandId, byte[] commandData) {
    super(messageId, commandId, commandData, (short)21);
    this.content = null;
    ByteBuffer buffer = ByteBuffer.wrap(commandData, 1, commandData.length - 1).order(ByteOrder.LITTLE_ENDIAN);
    if (getErrorCode() == 0) {
      int contentLength = 0xFFFF & buffer.getShort();
      try {
        byte[] strData = new byte[contentLength];
        buffer.get(strData);
        this.content = new String(strData);
      } catch (Exception e) {
        throw new IllegalArgumentException();
      } 
    } 
  }
  
  public String getContent() {
    return this.content;
  }
  
  public String getTypeString() {
    return "Response to String Parameter Command";
  }
  
  public String getContentString() {
    return "";
  }
  
  public boolean doCompareResponseData(PSCommandResponse other) {
    if (other instanceof PSCommandResponseStringParameter)
      return (this.content.compareTo(((PSCommandResponseStringParameter)other).content) == 0); 
    return false;
  }
}
