package ubiik.wp.util;

import java.util.Date;
import java.util.logging.ConsoleHandler;
import java.util.logging.Level;
import java.util.logging.LogRecord;
import java.util.logging.Logger;
import java.util.logging.SimpleFormatter;

public class ApplicationLogger {
  private static final Logger LOGGER = Logger.getLogger(ApplicationLogger.class.getName());
  
  static {
    ConsoleHandler ch = new ConsoleHandler();
    Level logLevel = Level.OFF;
    ch.setLevel(logLevel);
    LOGGER.setLevel(logLevel);
    LOGGER.setUseParentHandlers(false);
    ch.setFormatter(new SimpleFormatter() {
          private static final String format = "[%1$tF %1$tT.%1$tL] [%2$-7s] %3$s %n";
          
          public synchronized String format(LogRecord lr) {
            return String.format("[%1$tF %1$tT.%1$tL] [%2$-7s] %3$s %n", new Object[] { new Date(lr
                    .getMillis()), lr
                  .getLevel().getLocalizedName(), lr
                  .getMessage() });
          }
        });
    LOGGER.addHandler(ch);
  }
  
  public static void debug(String msg) {
    LOGGER.fine(msg);
  }
  
  public static void info(String msg) {
    LOGGER.info(msg);
  }
}
