package ubiik.wp.view;

import java.io.IOException;
import java.util.ArrayList;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.control.Tab;
import javafx.scene.control.TabPane;
import ubiik.wp.controller.DevicesController;
import ubiik.wp.controller.MessageController;
import ubiik.wp.model.fpga.FPGARegister;

public class FPGAViewController extends BaseViewController {
  @FXML
  private TabPane tabPane;

  private ArrayList<FPGARegisterViewController> registerControllers;

  public FPGAViewController(DevicesController devicesController, MessageController messageController, CommandStatusReceiver commandStatusReceiver) {
    super(devicesController, messageController, commandStatusReceiver);
    this.registerControllers = new ArrayList<>();
  }

  public void initialize() {
    for (FPGARegister fpgaRegister : this.devicesController.getFpgaRegisters()) {
      FXMLLoader fpgaRegisterLoader = new FXMLLoader(getClass().getResource("/main/resources/ubiik/wp/admin/FPGARegisterView.fxml"));
      try {
        FPGARegisterViewController registerController = new FPGARegisterViewController(fpgaRegister, this.messageController, this.devicesController, this.commandStatusReceiver);
        this.registerControllers.add(registerController);
        fpgaRegisterLoader.setController(registerController);
        Parent registerPane = fpgaRegisterLoader.<Parent>load();
        Tab tab = new Tab();
        tab.setText("Reg" + fpgaRegister.getIndex());
        tab.setContent(registerPane);
        this.tabPane.getTabs().add(tab);
      } catch (IOException e) {
        e.printStackTrace();
      }
    }
  }

  public ArrayList<FPGARegisterViewController> getRegisterControllers() {
    return this.registerControllers;
  }

  public void doReloadView() {}
}
