package ubiik.wp.view;

import java.util.List;
import ubiik.wp.controller.DevicesController;
import ubiik.wp.controller.MessageController;
import ubiik.wp.controller.PSMessageStorage;
import ubiik.wp.model.messages.PSUplink;

public abstract class UplinkSamplesViewController extends ConnectionManagerViewController {
  protected PSUplink lastUplinkProcessed;
  
  public UplinkSamplesViewController(MessageController messageController, DevicesController devicesController) {
    super(messageController, devicesController);
    this.lastUplinkProcessed = null;
  }
  
  public void initialize() {
    super.initialize();
  }
  
  public void update() {
    refreshData();
  }
  
  public void doReloadView() {
    update();
  }
  
  protected abstract void processUplink(PSUplink paramPSUplink);
  
  protected void refreshData() {
    PSMessageStorage ms = PSMessageStorage.getInstance();
    List<PSUplink> uplinks = ms.getUplinks();
    int idx = 0;
    if (this.lastUplinkProcessed != null) {
      int lastIdx = uplinks.indexOf(this.lastUplinkProcessed);
      if (lastIdx >= 0)
        idx = lastIdx + 1; 
    } 
    while (idx < uplinks.size()) {
      PSUplink uplink = uplinks.get(idx);
      this.lastUplinkProcessed = uplink;
      processUplink(uplink);
      idx++;
    } 
  }
  
  public void disableMenuAndActions(boolean disable) {
    if (this.rootPane != null && this.rootPane.getCenter() != null)
      this.rootPane.getCenter().setDisable(disable); 
  }
}
