package ubiik.wp.view;

import java.io.IOException;
import java.net.URL;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import ubiik.wp.controller.DevicesController;
import ubiik.wp.controller.MessageController;

public abstract class WPMainViewController extends ConnectionManagerViewController {
  protected RefreshableViewController currentViewController;
  
  public WPMainViewController(MessageController mc, DevicesController dc) {
    super(mc, dc);
    this.currentViewController = null;
  }
  
  public Parent setCurrentView(RefreshableViewController viewController, Parent node, URL layoutResource) {
    if (node == null) {
      FXMLLoader loader = new FXMLLoader(layoutResource);
      try {
        loader.setController(viewController);
        node = loader.<Parent>load();
      } catch (IOException e) {
        e.printStackTrace();
      } 
    } 
    if (node != null) {
      if (this.currentViewController != null)
        this.currentViewController.onHide(); 
      this.currentViewController = viewController;
      this.currentViewController.onShow();
      this.rootPane.setCenter(node);
    } 
    return node;
  }
}
