package ubiik.wp.model.sdr;

public abstract class SDRParameter {
  public static final int SDRPARAM_UINT8 = 0;
  
  public static final int SDRPARAM_INT = 1;
  
  public static final int SDRPARAM_DOUBLE = 2;
  
  public static final int SDRPARAM_UINT_32 = 3;
  
  public static final String CATEGORY_TX = "tx";
  
  public static final String CATEGORY_RX_IN = "rx_in";
  
  public static final String CATEGORY_RX_OUT = "rx_out";
  
  private int id;
  
  private String name;
  
  private String description;
  
  private String category;
  
  public SDRParameter(int id, String name, String description, String category) {
    this.id = id;
    this.name = name;
    this.description = description;
    this.category = category;
  }
  
  public abstract boolean validateValue(String paramString);
  
  public abstract boolean setValuFromString(String paramString);
  
  public abstract byte[] getValueInBytes();
  
  public abstract byte getDataTypeCode();
  
  public abstract String getValueStr();
  
  public abstract String getMinStr();
  
  public abstract String getMaxStr();
  
  public abstract String getStepStr();
  
  public abstract String getDefaultStr();
  
  public int getId() {
    return this.id;
  }
  
  public String getName() {
    return this.name;
  }
  
  public String getDescription() {
    return this.description;
  }
  
  public String getCategory() {
    return this.category;
  }
}
