package ubiik.wp.qa.model;

import java.util.Calendar;
import ubiik.utils.communication.ProgressDelegate;
import ubiik.wp.ami.controller.UUTestResult;
import ubiik.wp.controller.MessageController;

public abstract class PSMessageStressTest extends BSTest {
  protected long millisInterval;
  
  protected Integer totalIterations;
  
  protected Long millisRuntime;
  
  protected int totalIts;
  
  protected long timeRunning;
  
  protected MessageController messageController;
  
  public PSMessageStressTest(ProgressDelegate progressDelegate, long millisInterval, Integer totalIterations, Long millisRuntime, MessageController messageController) {
    super(progressDelegate);
    this.millisInterval = millisInterval;
    this.totalIterations = totalIterations;
    this.millisRuntime = millisRuntime;
    this.messageController = messageController;
  }
  
  protected abstract boolean runIteration(UUTestResult paramUUTestResult, StringBuilder paramStringBuilder, long paramLong1, Long paramLong, long paramLong2);
  
  protected abstract void setTestResult(StringBuilder paramStringBuilder);
  
  public void run() {
    this.doRun.set(true);
    StringBuilder sb = new StringBuilder();
    boolean finished = false;
    this.totalIts = 0;
    this.timeRunning = 0L;
    long timeStart = Calendar.getInstance().getTime().getTime();
    this.testResult.setSuccess(true);
    while (this.doRun.get() && !finished) {
      finished = runIteration(this.testResult, sb, timeStart, this.millisRuntime, this.millisInterval);
      this.totalIts++;
      if (this.totalIterations != null && this.totalIts >= this.totalIterations.intValue())
        finished = true; 
      this.timeRunning = Calendar.getInstance().getTime().getTime() - timeStart;
      if (this.millisRuntime != null && this.timeRunning > this.millisRuntime.longValue())
        finished = true; 
    } 
    this.doRun.set(false);
    setTestResult(sb);
    this.progressDelegate.progressFinished(null);
  }
}
